#!/bin/bash

# replace environment variables in config files
perl -pi -e 's/\$\{DSPACE_USER\}/$ENV{DSPACE_USER}/; s/\$\{DSPACE_PASSWORD\}/$ENV{DSPACE_PASSWORD}/; s/\$\{MAIL_USER\}/$ENV{MAIL_USER}/; s/\$\{MAIL_PASSWORD\}/$ENV{MAIL_PASSWORD}/; s/\$\{DSPACE_DBNAME\}/$ENV{DSPACE_DBNAME}/; s/\$\{DSPACE_UTILSDBNAME\}/$ENV{DSPACE_UTILSDBNAME}/;' /opt/repository/sources/dspace/local.properties
perl -pi -e 's/\$\{DSPACE_USER\}/$ENV{DSPACE_USER}/; s/\$\{DSPACE_PASSWORD\}/$ENV{DSPACE_PASSWORD}/; s/\$\{MAIL_USER\}/$ENV{MAIL_USER}/; s/\$\{MAIL_PASSWORD\}/$ENV{MAIL_PASSWORD}/; s/\$\{DSPACE_DBNAME\}/$ENV{DSPACE_DBNAME}/; s/\$\{DSPACE_UTILSDBNAME\}/$ENV{DSPACE_UTILSDBNAME}/;' /opt/repository/sources/dspace/target/local.properties
perl -pi -e 's/\$\{DSPACE_USER\}/$ENV{DSPACE_USER}/; s/\$\{DSPACE_PASSWORD\}/$ENV{DSPACE_PASSWORD}/; s/\$\{MAIL_USER\}/$ENV{MAIL_USER}/; s/\$\{MAIL_PASSWORD\}/$ENV{MAIL_PASSWORD}/; s/\$\{DSPACE_DBNAME\}/$ENV{DSPACE_DBNAME}/; s/\$\{DSPACE_UTILSDBNAME\}/$ENV{DSPACE_UTILSDBNAME}/;' /opt/lindat-dspace/installation/config/dspace.cfg
perl -pi -e 's/\$\{DSPACE_USER\}/$ENV{DSPACE_USER}/; s/\$\{DSPACE_PASSWORD\}/$ENV{DSPACE_PASSWORD}/; s/\$\{MAIL_USER\}/$ENV{MAIL_USER}/; s/\$\{MAIL_PASSWORD\}/$ENV{MAIL_PASSWORD}/; s/\$\{DSPACE_DBNAME\}/$ENV{DSPACE_DBNAME}/; s/\$\{DSPACE_UTILSDBNAME\}/$ENV{DSPACE_UTILSDBNAME}/;' /opt/lindat-dspace/installation/config/modules/lr.cfg

# adapt handle config
perl -pi -e 's/\$\{HANDLE_USER\}/$ENV{HANDLE_USER}/; s/\$\{HANDLE_PASSWORD\}/$ENV{HANDLE_PASSWORD}/; s/\$\{HANDLE_DBNAME\}/$ENV{HANDLE_DBNAME}/;' /opt/lindat-dspace/installation/handle-server/config.dct

# start handle server
/etc/init.d/handle-server start

# initialize statistics & co
cd /opt/repository/workspace/scripts
make init_statistics

# Start cron job in the background
cron_hack(){
    INIT="false"
    while (true); do
        # the first time, wait for tomcat to start...
        [ "$INIT" = "false" ] && sleep 180 && INIT="true"

        set -x
        LOGID=$(( (LOGID+1) % 5))
        LOG="/tmp/entrypoint.log.$LOGID"
        echo "$LOG" > $LOG
        timeout -k 30 300 make update_oai | tee -a $LOG
        timeout -k 30 300 make update_statistics | tee -a $LOG
        timeout -k 30 300 make update_sitemap | tee -a $LOG
        timeout -k 30 300 make lift_embargos | tee -a $LOG
        timeout -k 30 300 make update_openaire_cache | tee -a $LOG
        timeout -k 30 300 make update_discovery | tee -a $LOG
        timeout -k 30 300 make send_info | tee -a $LOG
        date >> $LOG
        echo "INIT DONE."
        wget https://healthchecks.local.iiegn.eu/ping/24a81cdc-2906-4faa-89b3-0d57541abef6 -T 10 -t 5 -O /dev/null
        set +x
        sleep 86400
    done
}
cron_hack &

# start tomcat
/opt/tomcat8/bin/catalina.sh run
